import { Meta, Typeset, Story, Canvas } from '@storybook/blocks';
import { moduleMetadata } from '@storybook/angular';
import { ButtonComponent, ButtonModule } from '@coyoapp/ui/button';
import { IconModule } from '@coyoapp/ui/icon';
import { width } from './util/decorator';
import { cuiDemo } from './util/demo';
import { demoSpacing, demoMargin } from './util/utilities';
import * as UtilitiesSpacingStories from './Utilities-spacing.stories';

<Meta of={UtilitiesSpacingStories} />

# Spacings

Assign responsive-friendly `margin` or `padding` values to an element or a subset of its sides with shorthand classes. Includes support for individual properties, all properties, and vertical and horizontal properties. Classes are built from a map ranging from .25rem to 1.5rem.

The classes are named using the format `.cui-{property}{sides}-{size}`.

Where *property* is one of:

* `m` - for classes that set `margin`
* `p` - for classes that set `padding`

Where *sides* is one of:

* `t` - for classes that set `margin-top` or `padding-top`
* `l` - for classes that set `margin-left` or `padding-left`
* `b` - for classes that set `margin-bottom` or `padding-bottom`
* `r` - for classes that set `margin-right` or `padding-right`
* `h` - for classes that set both `*-left` and `*-right`
* `v` - for classes that set both `*-top` and `*-bottom`
* `blank` - for classes that set a margin or padding on all 4 sides of the element

Where *size* is one of:

* `auto` - for classes that set the margin to `auto`
* `xl` - for classes that set the margin or padding to `2rem`
* `l` - for classes that set the margin or padding to `1.5rem`
* `m` - for classes that set the margin or padding to `1rem`
* `s` - for classes that set the margin or padding to `0.5rem`
* `xs` - for classes that set the margin or padding to `0.25rem`
* `0` - for classes that eliminate the margin or padding by setting it to `0`

<Canvas withSource="open">
  <Story of={UtilitiesSpacingStories.Spacings} />
</Canvas>

## Negative button margins

Simply align buttons to adjacent text by using shorthand classes. The classes will negate the additional padding of a button using negative margin(s).

The classes are named using the format `.cui-button-pull-out-{sides}`.

Where *sides* is one of:

* `t` - to negate the `padding-top`
* `l` - to negate the `padding-left`
* `b` - to negate the `padding-bottom`
* `r` - to negate the `padding-right`
* `h` - to negate the `padding-left` and `padding-right`
* `v` - to negate the `padding-top` and `padding-bottom`
* `blank` - for classes that negate the margin on all 4 sides of the button

<Canvas withSource="open">
  <Story of={UtilitiesSpacingStories.NegativeButtonMargins} />
</Canvas>
